function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "base";
    this.args = arguments[0] || {};
    if (arguments[0]) {
        {
            __processArg(arguments[0], "__parentSymbol");
        }
        {
            __processArg(arguments[0], "$model");
        }
        {
            __processArg(arguments[0], "__itemTemplate");
        }
    }
    var $ = this;
    var exports = {};
    exports.destroy = function() {};
    _.extend($, $.__views);
    Alloy.Globals.openWindows = [];
    require("api");
    openWindow = function(win) {
        var last_win = Alloy.Globals.openWindows[Alloy.Globals.openWindows.length - 1];
        if (last_win && last_win.id === win.id) {
            Ti.API.info(" ###########################################################");
            Ti.API.info(" ####### This window is already open, nothing to do! #######");
            Ti.API.info(" ###########################################################");
        } else {
            last_win && Ti.API.info(last_win.id);
            Alloy.Globals.openWindows.push(win);
            win.open({
                animated: false
            });
        }
        win.addEventListener("close", function() {
            Alloy.Globals.openWindows.pop();
        });
    };
    close = function(win) {
        win.close({
            animated: false
        });
    };
    goHome = function() {
        var windows = Alloy.Globals.openWindows;
        var lastWindow;
        for (var i = 0, j = windows.length; j > i; i++) {
            var win = windows[j - i - 1];
            0 === i ? lastWindow = win : close(win);
        }
        close(lastWindow);
    };
    goToSettings = function() {
        var windows = Alloy.Globals.openWindows;
        var lastWindow;
        for (var i = 0, j = windows.length; j > i; i++) {
            var win = windows[j - i - 1];
            if (0 === i) lastWindow = win; else if (i !== j - 1) {
                if ("win_settings" === win.id) break;
                close(win);
            }
        }
        close(lastWindow);
    };
    openAlertWindow = function(image, msg, btn_text) {
        var win = Ti.UI.createWindow({
            id: "win_alert"
        });
        var v = Alloy.createController("retry_error", {
            image: image,
            msg: msg,
            btn_text: btn_text
        }).getView();
        win.add(v);
        v.addEventListener("onBtnClick", function() {
            win.close();
        });
        v.removeEventListener("onBtnClick", function() {});
        openWindow(win);
    };
    log = function(tag, msg) {
        if (Alloy.Globals.DEBUG) {
            Ti.API.info("=== DEBUG API ===");
            Ti.API.info(tag + ": " + msg);
        }
    };
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;