function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function decrementFloorNumber() {
        if (-10 == floor) $.minFloor.show(); else {
            floor -= 1;
            $.selection.text = floor + "";
        }
    }
    function incrementFloorNumber() {
        if (10 == floor) $.maxFloor.show(); else {
            floor += 1;
            $.selection.text = floor + "";
        }
    }
    function cancelDialog() {
        $.container.hide();
    }
    function saveFloorSelection() {
        currentFloor = floor;
        var msg = floor + "";
        Ti.API.debug("[saveBtn-FloorChange] change:" + msg);
        Ti.App.fireEvent("setLevel", {
            level: msg
        });
        Ti.App.SELECTED_FLOOR = currentFloor;
        true === Ti.App.routeIsDrawn && Ti.App.fireEvent("drawLevelRouteLine", {
            level: currentFloor
        });
        $.container.hide();
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "floor_select";
    this.args = arguments[0] || {};
    if (arguments[0]) {
        {
            __processArg(arguments[0], "__parentSymbol");
        }
        {
            __processArg(arguments[0], "$model");
        }
        {
            __processArg(arguments[0], "__itemTemplate");
        }
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.container = Ti.UI.createView({
        height: Ti.UI.FILL,
        width: Ti.UI.FILL,
        id: "container"
    });
    $.__views.container && $.addTopLevelView($.__views.container);
    $.__views.background = Ti.UI.createView({
        backgroundColor: "transparent",
        height: Ti.UI.FILL,
        width: Ti.UI.FILL,
        id: "background"
    });
    $.__views.container.add($.__views.background);
    $.__views.modal_dialog = Ti.UI.createView({
        width: "75%",
        height: "40%",
        backgroundColor: "#F3A327",
        borderRadius: 5,
        id: "modal_dialog"
    });
    $.__views.background.add($.__views.modal_dialog);
    $.__views.minFloor = Ti.UI.createNotification({
        id: "minFloor",
        message: "Mininum floor level reached",
        duration: Ti.UI.NOTIFICATION_DURATION_SHORT
    });
    $.__views.modal_dialog.add($.__views.minFloor);
    $.__views.maxFloor = Ti.UI.createNotification({
        id: "maxFloor",
        message: "Maximum floor level reached",
        duration: Ti.UI.NOTIFICATION_DURATION_SHORT
    });
    $.__views.modal_dialog.add($.__views.maxFloor);
    $.__views.header = Ti.UI.createLabel({
        font: {
            fontFamily: "Raleway-Medium",
            fontSize: "28dp",
            fontWeight: "bold"
        },
        color: "white",
        width: Ti.UI.FILL,
        height: "50dp",
        top: 0,
        text: "Select floor level",
        textAlign: Ti.UI.TEXT_ALIGNMENT_CENTER,
        backgroundColor: "#000",
        id: "header"
    });
    $.__views.modal_dialog.add($.__views.header);
    $.__views.selection = Ti.UI.createLabel({
        font: {
            fontFamily: "Raleway-Medium",
            fontSize: "24dp",
            fontWeight: "bold"
        },
        color: "white",
        top: "85dp",
        text: Ti.App.SELECTED_FLOOR,
        id: "selection"
    });
    $.__views.modal_dialog.add($.__views.selection);
    $.__views.decrementFloor = Ti.UI.createButton({
        width: "60dp",
        height: "40dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "24dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        top: "80dp",
        heigth: "120dp",
        backgroundColor: "#526887",
        left: "30dp",
        title: "-",
        id: "decrementFloor"
    });
    $.__views.modal_dialog.add($.__views.decrementFloor);
    decrementFloorNumber ? $.__views.decrementFloor.addEventListener("click", decrementFloorNumber) : __defers["$.__views.decrementFloor!click!decrementFloorNumber"] = true;
    $.__views.incrementFloor = Ti.UI.createButton({
        width: "60dp",
        height: "40dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "24dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        top: "80dp",
        heigth: "120dp",
        backgroundColor: "#526887",
        right: "30dp",
        title: "+",
        id: "incrementFloor"
    });
    $.__views.modal_dialog.add($.__views.incrementFloor);
    incrementFloorNumber ? $.__views.incrementFloor.addEventListener("click", incrementFloorNumber) : __defers["$.__views.incrementFloor!click!incrementFloorNumber"] = true;
    $.__views.cancelDialog = Ti.UI.createButton({
        width: "110dp",
        height: "40dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "18dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        bottom: "30dp",
        backgroundColor: "#526887",
        left: "15dp",
        title: "Cancel",
        id: "cancelDialog"
    });
    $.__views.modal_dialog.add($.__views.cancelDialog);
    cancelDialog ? $.__views.cancelDialog.addEventListener("click", cancelDialog) : __defers["$.__views.cancelDialog!click!cancelDialog"] = true;
    $.__views.saveModification = Ti.UI.createButton({
        width: "110dp",
        height: "40dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "18dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        bottom: "30dp",
        backgroundColor: "#526887",
        right: "15dp",
        title: "Save",
        id: "saveModification"
    });
    $.__views.modal_dialog.add($.__views.saveModification);
    saveFloorSelection ? $.__views.saveModification.addEventListener("click", saveFloorSelection) : __defers["$.__views.saveModification!click!saveFloorSelection"] = true;
    exports.destroy = function() {};
    _.extend($, $.__views);
    var currentFloor = Ti.App.SELECTED_FLOOR;
    var floor = currentFloor;
    __defers["$.__views.decrementFloor!click!decrementFloorNumber"] && $.__views.decrementFloor.addEventListener("click", decrementFloorNumber);
    __defers["$.__views.incrementFloor!click!incrementFloorNumber"] && $.__views.incrementFloor.addEventListener("click", incrementFloorNumber);
    __defers["$.__views.cancelDialog!click!cancelDialog"] && $.__views.cancelDialog.addEventListener("click", cancelDialog);
    __defers["$.__views.saveModification!click!saveFloorSelection"] && $.__views.saveModification.addEventListener("click", saveFloorSelection);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;