function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function iterateOverPoiFiles(urlList, iterator, callback) {
        function report() {
            nextRequest++;
            nextRequest === urlList.length ? callback() : iterator(urlList[nextRequest], report);
        }
        var nextRequest = 0;
        iterator(urlList[0], report);
    }
    function search() {
        openWindow(Alloy.createController("search_place", {
            obj: $.b_search,
            currentLocation: currentLocation
        }).getView());
    }
    function findMyPosition() {
        if ($.b_location.enable) {
            $.b_location.enable = false;
            $.b_location.backgroundImage = "/btn_gps_disabled.png";
            $.b_michrofone.checked = false;
            $.b_michrofone.backgroundImage = "/btn_voice_disabled.png";
            alert_msg_shown = false;
            toolkit.stopTracking();
        } else {
            $.b_location.enable = true;
            $.b_location.backgroundImage = "/btn_gps.png";
            startLocation();
        }
    }
    function startLocation() {
        if ($.b_location.enable) {
            if (!toolkit.isGpsEnabled() && !alert_msg_shown) {
                alert_msg_shown = true;
                openAlertWindow("/happy_face.png", "Enabling your GPS will improve your location", "Got it!");
            }
            var data_for_proxy = toolkit.getAllInfos();
            api.getAccurateLocation(data_for_proxy, {
                onSuccess: function(res) {
                    currentLocation = res.response.position;
                    Ti.API.info("==> " + JSON.stringify(currentLocation));
                    setTimeout(function() {
                        Ti.App.fireEvent("updateMap", {
                            what: "mylocation",
                            data: [ parseFloat(currentLocation.lon), parseFloat(currentLocation.lat) ]
                        });
                    }, 100);
                    res.response.indoor ? $.b_inside.visible || ($.b_inside.visible = true) : !res.response.indoor && $.b_inside.visible && ($.b_inside.visible = false);
                },
                onError: function() {}
            });
            setTimeout(function() {
                startLocation();
            }, CFG.update_interval);
        }
    }
    function getLastKnownBestLocation() {
        toolkit.getLastKnownBestLocation(function(data) {
            Ti.API.info(JSON.stringify(data));
            if (data.message) alert(data.message); else {
                var lastLoc = JSON.parse(data.container);
                currentLocation.lat = lastLoc.latitude;
                currentLocation.lon = lastLoc.longitude;
                setTimeout(function() {
                    Ti.App.fireEvent("updateMap", {
                        what: "mylocation",
                        data: [ parseFloat(currentLocation.lon), parseFloat(currentLocation.lat) ]
                    });
                }, 100);
            }
        });
    }
    function getIndoor() {
        $.b_location.enable = false;
        $.b_location.backgroundImage = "/btn_gps_disabled.png";
        toolkit.stopTracking();
        openWindow(Alloy.createController("indoor").getView());
    }
    function stopMicrophone() {
        if ($.b_michrofone.checked) {
            $.b_michrofone.checked = false;
            $.b_michrofone.backgroundImage = "/btn_voice_disabled.png";
            if (!textToSpeech.isSpeaking()) {
                Ti.API.info("nothing to stop, press play first");
                return;
            }
            textToSpeech.stopSpeaking();
        } else if ($.b_location.enable) {
            $.b_michrofone.checked = true;
            $.b_michrofone.backgroundImage = "/btn_voice.png";
        }
    }
    function scan() {
        var titaniumBarcode = require("com.mwaysolutions.barcode");
        titaniumBarcode.scan({
            success: function(e) {
                var id = e.barcode;
                var value;
                var number = Number(parseInt(id, 10));
                if (isNaN(number)) {
                    var temporaryObject = JSON.parse(id);
                    value = temporaryObject["id"];
                } else value = id;
                var postData = {};
                postData["objectId"] = Ti.Platform.macaddress;
                postData["localizationSystems"] = [];
                postData["localizationSystems"].push({
                    localizationSystem_id: "qrcode",
                    entries: [ {
                        id: value
                    } ]
                });
                api.getAccurateLocation(JSON.stringify(postData), {
                    onSuccess: function(result) {
                        currentLocation.lat = result.response.position.lat;
                        currentLocation.lon = result.response.position.lon;
                        Ti.App.fireEvent("updateMap", {
                            what: "mylocation",
                            data: [ parseFloat(currentLocation.lon), parseFloat(currentLocation.lat) ]
                        });
                        Alloy.Globals.setLevel(result.response.position.z);
                    },
                    onError: function(e) {
                        alert(e);
                    }
                });
            },
            error: function(err) {
                Ti.API.info(JSON.stringify(err));
            },
            cancel: function() {
                Ti.API.info("Cancel received");
            }
        });
    }
    function openListnavigation() {
        openWindow(Alloy.createController("navigation_list").getView());
    }
    function openFloorDialog() {
        $.home.add(Alloy.createController("floor_select").getView());
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "home";
    this.args = arguments[0] || {};
    if (arguments[0]) {
        {
            __processArg(arguments[0], "__parentSymbol");
        }
        {
            __processArg(arguments[0], "$model");
        }
        {
            __processArg(arguments[0], "__itemTemplate");
        }
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.home = Ti.UI.createView({
        id: "home"
    });
    $.__views.home && $.addTopLevelView($.__views.home);
    $.__views.v_action_bar = Alloy.createController("action_bar", {
        id: "v_action_bar",
        __parentSymbol: $.__views.home
    });
    $.__views.v_action_bar.setParent($.__views.home);
    $.__views.v_map_container = Ti.UI.createView({
        top: "50dp",
        bottom: "65dp",
        id: "v_map_container"
    });
    $.__views.home.add($.__views.v_map_container);
    $.__views.webview = Ti.UI.createWebView({
        top: 0,
        left: 0,
        right: 0,
        bottom: 0,
        id: "webview",
        url: "/mymap.html"
    });
    $.__views.v_map_container.add($.__views.webview);
    $.__views.b_floor = Ti.UI.createButton({
        width: "60dp",
        height: "60dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        backgroundColor: "transparent",
        top: "10dp",
        backgroundImage: "/btn_floor.png",
        visible: true,
        id: "b_floor"
    });
    $.__views.v_map_container.add($.__views.b_floor);
    openFloorDialog ? $.__views.b_floor.addEventListener("click", openFloorDialog) : __defers["$.__views.b_floor!click!openFloorDialog"] = true;
    $.__views.b_location = Ti.UI.createButton({
        width: "60dp",
        height: "60dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        backgroundColor: "transparent",
        right: "10dp",
        bottom: "10dp",
        backgroundImage: "/btn_gps_disabled.png",
        enalbe: false,
        id: "b_location"
    });
    $.__views.v_map_container.add($.__views.b_location);
    findMyPosition ? $.__views.b_location.addEventListener("click", findMyPosition) : __defers["$.__views.b_location!click!findMyPosition"] = true;
    $.__views.b_michrofone = Ti.UI.createButton({
        width: "60dp",
        height: "60dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        backgroundColor: "transparent",
        left: "10dp",
        bottom: "60dp",
        backgroundImage: "/btn_voice_disabled.png",
        visible: false,
        checked: false,
        id: "b_michrofone"
    });
    $.__views.v_map_container.add($.__views.b_michrofone);
    stopMicrophone ? $.__views.b_michrofone.addEventListener("click", stopMicrophone) : __defers["$.__views.b_michrofone!click!stopMicrophone"] = true;
    $.__views.b_inside = Ti.UI.createButton({
        width: "60dp",
        height: "60dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        backgroundColor: "transparent",
        right: "10dp",
        bottom: "100dp",
        backgroundImage: "/btn_indoor.png",
        visible: false,
        id: "b_inside"
    });
    $.__views.v_map_container.add($.__views.b_inside);
    getIndoor ? $.__views.b_inside.addEventListener("click", getIndoor) : __defers["$.__views.b_inside!click!getIndoor"] = true;
    $.__views.b_scan = Ti.UI.createButton({
        width: "66dp",
        height: "66dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        right: "8dp",
        bottom: "70dp",
        backgroundImage: "/btn_qrcode.png",
        visible: true,
        id: "b_scan"
    });
    $.__views.v_map_container.add($.__views.b_scan);
    scan ? $.__views.b_scan.addEventListener("click", scan) : __defers["$.__views.b_scan!click!scan"] = true;
    $.__views.b_list_navigation = Ti.UI.createButton({
        width: "60dp",
        height: "60dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        backgroundColor: "transparent",
        left: "10dp",
        bottom: "0dp",
        backgroundImage: "/btn_step.png",
        visible: false,
        id: "b_list_navigation"
    });
    $.__views.v_map_container.add($.__views.b_list_navigation);
    openListnavigation ? $.__views.b_list_navigation.addEventListener("click", openListnavigation) : __defers["$.__views.b_list_navigation!click!openListnavigation"] = true;
    $.__views.v_footer = Ti.UI.createView({
        backgroundImage: "/footer.jpg",
        left: 0,
        right: 0,
        height: "65dp",
        bottom: 0,
        id: "v_footer"
    });
    $.__views.home.add($.__views.v_footer);
    search ? $.__views.v_footer.addEventListener("click", search) : __defers["$.__views.v_footer!click!search"] = true;
    $.__views.b_search = Ti.UI.createButton({
        width: "30dp",
        height: "30dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        left: "18%",
        backgroundImage: "/whiteSearch.png",
        touchEnabled: false,
        id: "b_search"
    });
    $.__views.v_footer.add($.__views.b_search);
    $.__views.lbl_search = Ti.UI.createLabel({
        font: {
            fontFamily: "Raleway-Medium",
            fontSize: "22dp"
        },
        color: "white",
        text: L("search_place"),
        touchEnabled: false,
        id: "lbl_search"
    });
    $.__views.v_footer.add($.__views.lbl_search);
    exports.destroy = function() {};
    _.extend($, $.__views);
    var toolkit = require("eu.ilocate.toolkit");
    var CFG = Alloy.Globals.CONFIG;
    var api = require("api");
    var utterance = require("bencoding.utterance");
    var textToSpeech = utterance.createSpeech();
    var urls = [];
    toolkit.init(CFG.combain_key);
    api.getPoiFile("categories.json", {
        success: function(data) {
            Alloy.Globals.CACHED_POI["categories"] = JSON.parse(data);
            var poiCategories = Alloy.Globals.CACHED_POI["categories"];
            var categLength = poiCategories.length;
            for (var i = 0; categLength > i; i++) {
                var buff = poiCategories[i];
                for (var key in buff) buff.hasOwnProperty(key) && "URL" == key && urls.push(buff[key]);
            }
            iterateOverPoiFiles(urls, function(url, report) {
                api.getPoiFile(url, {
                    success: function(poiData) {
                        Alloy.Globals.CACHED_POI[url] = JSON.parse(poiData);
                        report();
                    },
                    error: function(err) {
                        alert("Nu s-au putut prelua datele de pe portal " + err);
                    }
                });
            }, {});
        },
        error: function(err) {
            alert("Nu s-au putut prelua datele de pe portal " + err);
        }
    });
    var alert_msg_shown = false;
    var currentLocation = {
        lat: CFG.pilot_pos_lat,
        lon: CFG.pilot_pos_lon
    };
    var destination = {};
    var routeOption = {
        mode: "WALK",
        drawn: false
    };
    var item;
    Ti.UI.createActivityIndicator({
        style: Ti.UI.ActivityIndicatorStyle.PLAIN,
        font: {
            fontFamily: "Helvetica Neue",
            fontSize: 18,
            fontWeight: "bold"
        },
        color: "Black",
        message: "Loading...",
        width: "auto",
        top: "50dp",
        left: "100dp",
        height: "80dp"
    });
    $.v_action_bar.getView("action_bar").addEventListener("onButtonClick", function() {
        $.webview.pause();
        openWindow(Alloy.createController("settings").getView());
    });
    $.webview.addEventListener("load", function() {
        log("load", "event");
        getLastKnownBestLocation();
    });
    Ti.App.addEventListener("navigation", function(e) {
        log("navigation", e.what);
        if ("speach" == e.what && $.b_michrofone.checked) {
            Ti.API.info(e.message);
            if (textToSpeech.isSpeaking()) {
                Ti.API.info("already speaking");
                return;
            }
            textToSpeech.startSpeaking({
                text: e.message
            });
        } else if ("route" == e.what) api.getRoutes(currentLocation.lat + "," + currentLocation.lon, destination.lat + "," + destination.lon + "," + destination.z, routeOption.mode, {
            success: function(data) {
                Ti.App.fireEvent("setLevel", {
                    level: "0"
                });
                Ti.App.routeIsDrawn = true;
                Ti.App.fireEvent("updateMap", {
                    what: "mySoonToBeRoute",
                    data: data,
                    destination: [ destination.lat, destination.lon ],
                    destinationLevel: Ti.App.SELECTED_FLOOR
                });
                Ti.App.SELECTED_FLOOR = 0;
                var db = require("dbHelper");
                db.addstep(data[0].steps);
            }
        }); else if ("button" == e.what) {
            $.b_michrofone.visible = true;
            $.b_michrofone.checked = true;
            $.b_list_navigation.visible = true;
            if ($.b_location.enable) {
                $.b_michrofone.checked = true;
                $.b_michrofone.backgroundImage = "/btn_voice.png";
            }
            var dest = e.destination.split(",");
            destination["lat"] = dest[0];
            destination["lon"] = dest[1];
            destination["z"] = dest[2];
            routeOption.mode = e.routeOption;
        }
    });
    Ti.App.addEventListener("showRoute", function(e) {
        log("showRoute", e.what);
        switch (e.what) {
          case "show":
            if (void 0 !== currentLocation.lat && void 0 !== currentLocation.lon) if (void 0 !== item) {
                Ti.App.fireEvent("navigation", {
                    what: "button",
                    destination: item.id_question,
                    routeOption: routeOption.mode
                });
                setTimeout(function() {
                    Ti.App.fireEvent("navigation", {
                        what: "route",
                        destination: destination
                    });
                }, 200);
                routeOption.drawn = true;
            } else alert("You did not choose a location yet.");
            break;

          case "save":
            routeOption.mode = e.routeOption;
            item = e.item;
            break;

          case "cancel":
            if (true === routeOption.drawn) {
                $.b_michrofone.visible = false;
                $.b_list_navigation.visible = false;
                setTimeout(function() {
                    Ti.App.fireEvent("updateMap", {
                        what: "clear"
                    });
                }, 100);
                setTimeout(function() {
                    Ti.App.fireEvent("updateMap", {
                        what: "mylocation",
                        data: [ parseFloat(currentLocation.lon), parseFloat(currentLocation.lat) ]
                    });
                }, 100);
                item = void 0;
                routeOption.drawn = false;
                var db = require("dbHelper");
                db.flush();
                Ti.App.routeIsDrawn = false;
                Ti.App.SELECTED_FLOOR = 0;
                Ti.App.fireEvent("setLevel", {
                    level: Ti.App.SELECTED_FLOOR + ""
                });
            } else alert("You hadn't draw any route right now!");
        }
    });
    __defers["$.__views.b_floor!click!openFloorDialog"] && $.__views.b_floor.addEventListener("click", openFloorDialog);
    __defers["$.__views.b_location!click!findMyPosition"] && $.__views.b_location.addEventListener("click", findMyPosition);
    __defers["$.__views.b_michrofone!click!stopMicrophone"] && $.__views.b_michrofone.addEventListener("click", stopMicrophone);
    __defers["$.__views.b_inside!click!getIndoor"] && $.__views.b_inside.addEventListener("click", getIndoor);
    __defers["$.__views.b_scan!click!scan"] && $.__views.b_scan.addEventListener("click", scan);
    __defers["$.__views.b_list_navigation!click!openListnavigation"] && $.__views.b_list_navigation.addEventListener("click", openListnavigation);
    __defers["$.__views.v_footer!click!search"] && $.__views.v_footer.addEventListener("click", search);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;