function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function scan() {
        var titaniumBarcode = require("com.mwaysolutions.barcode");
        var barcode = "115307";
        var api = require("api");
        api.getAccurateLocation(prepareDataForProxy(barcode), {
            onSuccess: function(result) {
                alert(1);
                alert(result);
                drawPin(parseInt(result.response.position.x, radix), parseInt(result.response.position.y, radix));
            },
            onError: function(e) {
                alert(e);
            }
        });
        titaniumBarcode.scan({
            success: function(e) {
                var api = require("api");
                api.getAccurateLocation(prepareDataForProxy(e.barcode), {
                    onSuccess: function(result) {
                        alert(e.barcode);
                        drawPin(parseInt(result.response.position.x, radix), parseInt(result.response.position.y, radix));
                    },
                    onError: function(e) {
                        alert(e);
                    }
                });
            },
            error: function(err) {
                Ti.API.info(JSON.stringify(err));
            },
            cancel: function() {
                Ti.API.info("Cancel received");
            }
        });
    }
    function drawPin(x, y) {
        $.img_pin.left = 10 * x + "dp";
        $.img_pin.top = 10 * y + "dp";
        Ti.API.info(JSON.stringify($.img_pin));
        $.img_pin.visible || ($.img_pin.visible = true);
    }
    function prepareDataForProxy(id) {
        var postData = {};
        postData["positionType"] = "relative";
        postData["objectId"] = Ti.Platform.macaddress;
        postData["localizationSystems"] = [];
        postData["localizationSystems"].push({
            localizationSystem_id: "qrcode",
            entries: [ {
                id: id
            } ]
        });
        return JSON.stringify(postData);
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "indoor";
    this.args = arguments[0] || {};
    if (arguments[0]) {
        {
            __processArg(arguments[0], "__parentSymbol");
        }
        {
            __processArg(arguments[0], "$model");
        }
        {
            __processArg(arguments[0], "__itemTemplate");
        }
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.win_indoor = Ti.UI.createWindow({
        backgroundColor: "white",
        windowSoftInputMode: Ti.UI.Android.SOFT_INPUT_ADJUST_UNSPECIFIED,
        id: "win_indoor"
    });
    $.__views.win_indoor && $.addTopLevelView($.__views.win_indoor);
    $.__views.v_action_bar = Alloy.createController("action_bar", {
        id: "v_action_bar",
        __parentSymbol: $.__views.win_indoor
    });
    $.__views.v_action_bar.setParent($.__views.win_indoor);
    $.__views.v_container = Ti.UI.createView({
        left: 0,
        right: 0,
        top: "60dp",
        bottom: 0,
        id: "v_container"
    });
    $.__views.win_indoor.add($.__views.v_container);
    $.__views.img_map = Ti.UI.createImageView({
        left: 0,
        right: 0,
        top: 0,
        bottom: 0,
        id: "img_map"
    });
    $.__views.v_container.add($.__views.img_map);
    $.__views.img_pin = Ti.UI.createImageView({
        visible: false,
        width: "20dp",
        height: "30dp",
        backgroundImage: "/marker.png",
        id: "img_pin"
    });
    $.__views.v_container.add($.__views.img_pin);
    $.__views.b_scan = Ti.UI.createButton({
        width: "80dp",
        height: "80dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        right: "10dp",
        bottom: "50dp",
        backgroundImage: "/btn_qrcode.png",
        id: "b_scan"
    });
    $.__views.v_container.add($.__views.b_scan);
    scan ? $.__views.b_scan.addEventListener("click", scan) : __defers["$.__views.b_scan!click!scan"] = true;
    exports.destroy = function() {};
    _.extend($, $.__views);
    $.img_map.image = "/layout.png";
    var radix = 10;
    $.v_action_bar.getView("action_bar").addEventListener("onButtonClick", function(e) {
        "close" == e.action ? close($.win_indoor) : openWindow(Alloy.createController("settings").getView());
    });
    $.win_indoor.addEventListener("close", function() {
        $.v_action_bar.getView("action_bar").removeEventListener("onButtonClick", function() {});
    });
    __defers["$.__views.b_scan!click!scan"] && $.__views.b_scan.addEventListener("click", scan);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;