function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function populateList(data) {
        var rows = [];
        for (var i = 0; i < data.length; i++) {
            var direction_text = data.at(i).get("relative_direction").split("_").join(" ");
            direction_text = direction_text.replace("CONTINUE ", "");
            var street_name = data.at(i).get("street_name");
            rows.push({
                id_question: data.at(i).get("latitude") + "," + data.at(i).get("longitude"),
                v_container: {
                    backgroundColor: "white"
                },
                img: {
                    image: "/" + directionDictionaryImage[data.at(i).get("relative_direction")]
                },
                lbl_street_name: {
                    text: blackNames[street_name.toLowerCase()] ? direction_text : street_name
                },
                lbl_distance: {
                    text: parseInt(data.at(i).get("distance")) + " meters"
                }
            });
            data[data.at(i).get("latitude") + "," + data.at(i).get("longitude")] = i;
        }
        var section = Ti.UI.createListSection({
            items: rows
        });
        $.listView.sections = [ section ];
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "navigation_list";
    this.args = arguments[0] || {};
    if (arguments[0]) {
        {
            __processArg(arguments[0], "__parentSymbol");
        }
        {
            __processArg(arguments[0], "$model");
        }
        {
            __processArg(arguments[0], "__itemTemplate");
        }
    }
    var $ = this;
    var exports = {};
    $.__views.win_navigation_list = Ti.UI.createWindow({
        backgroundColor: "white",
        windowSoftInputMode: Ti.UI.Android.SOFT_INPUT_ADJUST_UNSPECIFIED,
        id: "win_navigation_list"
    });
    $.__views.win_navigation_list && $.addTopLevelView($.__views.win_navigation_list);
    $.__views.v_action_bar = Alloy.createController("action_bar", {
        id: "v_action_bar",
        __parentSymbol: $.__views.win_navigation_list
    });
    $.__views.v_action_bar.setParent($.__views.win_navigation_list);
    $.__views.b_ls_nav = Ti.UI.createButton({
        width: "95%",
        height: "40dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 5,
        id: "b_ls_nav",
        visible: "false"
    });
    $.__views.win_navigation_list.add($.__views.b_ls_nav);
    var __alloyId2 = {};
    var __alloyId4 = [];
    var __alloyId5 = {
        type: "Ti.UI.View",
        bindId: "v_container",
        childTemplates: function() {
            var __alloyId6 = [];
            var __alloyId7 = {
                type: "Ti.UI.ImageView",
                bindId: "img",
                properties: {
                    left: "20dp",
                    width: "25dp",
                    height: "25dp",
                    bindId: "img"
                }
            };
            __alloyId6.push(__alloyId7);
            var __alloyId8 = {
                type: "Ti.UI.View",
                childTemplates: function() {
                    var __alloyId9 = [];
                    var __alloyId10 = {
                        type: "Ti.UI.Label",
                        bindId: "lbl_street_name",
                        properties: {
                            font: {
                                fontFamily: "Raleway-Medium"
                            },
                            color: "black",
                            left: 0,
                            top: 0,
                            height: "25dp",
                            bindId: "lbl_street_name"
                        }
                    };
                    __alloyId9.push(__alloyId10);
                    var __alloyId11 = {
                        type: "Ti.UI.Label",
                        bindId: "lbl_distance",
                        properties: {
                            font: {
                                fontFamily: "Raleway-Medium"
                            },
                            color: "black",
                            left: 0,
                            bottom: 0,
                            height: "25dp",
                            bindId: "lbl_distance"
                        }
                    };
                    __alloyId9.push(__alloyId11);
                    return __alloyId9;
                }(),
                properties: {
                    left: "65dp",
                    right: 0,
                    top: "10dp",
                    bottom: "10dp"
                }
            };
            __alloyId6.push(__alloyId8);
            return __alloyId6;
        }(),
        properties: {
            left: 0,
            right: 0,
            height: "70dp",
            bindId: "v_container"
        }
    };
    __alloyId4.push(__alloyId5);
    var __alloyId3 = {
        properties: {
            name: "template",
            bindId: "id_question"
        },
        childTemplates: __alloyId4
    };
    __alloyId2["template"] = __alloyId3;
    $.__views.listView = Ti.UI.createListView({
        top: "60dp",
        templates: __alloyId2,
        id: "listView",
        defaultItemTemplate: "template",
        separatorColor: "transparent"
    });
    $.__views.win_navigation_list.add($.__views.listView);
    exports.destroy = function() {};
    _.extend($, $.__views);
    var db = require("dbHelper");
    var steps = db.getAllStep();
    var directionDictionaryImage = {
        DEPART: "",
        HARD_LEFT: "left.jpg",
        LEFT: "left.jpg",
        SLIGHTLY_LEFT: "slight_left.jpg",
        CONTINUE: "continue.jpg",
        SLIGHTLY_RIGHT: "slight_right.jpg",
        RIGHT: "right.jpg",
        HARD_RIGHT: "right.jpg",
        CIRCLE_CLOCKWISE: "",
        CIRCLE_COUNTERCLOCKWISE: "",
        ELEVATOR: "elevator.jpg",
        GO_DOWN_WITH_THE_ELEVATOR: "elevator_down.jpg",
        GO_UP_WITH_THE_ELEVATOR: "elevator_up.jpg",
        TURN_LEFT: "left.jpg",
        TURN_RIGHT: "right.jpg",
        GO_UP_THE_STAIRS: "stairs_up.jpg",
        GO_DOWN_THE_STAIRS: "stairs_down.jpg",
        GO_THROUGH_THE_STAIRS: "stairs.jpg",
        CONTINUE_THROUGH_THE_CORRIDOR: "continue.jpg",
        CONTINUE_SLIGHTLY_RIGHT_THROUGH_THE_CORRIDOR: "slight_right.jpg",
        CONTINUE_SLIGHTLY_LEFT_THROUGH_THE_CORRIDOR: "slight_left.jpg",
        CONTINUE_RIGHT_THROUGH_THE_CORRIDOR: "right.jpg",
        CONTINUE_LEFT_THROUGH_THE_CORRIDOR: "left.jpg",
        CONTINUE_HARD_RIGHT_THROUGH_THE_CORRIDOR: "right.jpg",
        CONTINUE_HARD_LEFT_THROUGH_THE_CORRIDOR: "left.jpg"
    };
    var blackNames = {
        hallway: 1,
        path: 1,
        sidewalk: 1
    };
    populateList(steps);
    $.v_action_bar.getView("action_bar").addEventListener("onButtonClick", function(e) {
        "close" == e.action ? close($.win_navigation_list) : openWindow(Alloy.createController("settings").getView());
    });
    $.win_navigation_list.addEventListener("close", function() {
        $.destroy();
    });
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;