function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function iterateThroughTemporalRoute(i, t) {
        setTimeout(function() {
            Ti.API.info("===> " + JSON.stringify(temporalRouteCOntainer[i]));
            setLocation(parseFloat(temporalRouteCOntainer[i]["latitude"]), parseFloat(temporalRouteCOntainer[i]["longitude"]));
            i += 1;
            i < temporalRouteCOntainer.length && iterateThroughTemporalRoute(i, t);
            return;
        }, 1e3 * t);
    }
    function getLastKnownBestLocation(callback) {
        Ti.API.info("===getLastKnownBestLocation===");
        toolkit.getLastKnownBestLocation(function(data) {
            Ti.API.info(JSON.stringify(data));
            if (data.message) {
                alert(data.message);
                callback();
            } else callback(JSON.parse(data.container));
        });
    }
    function speak(msg) {
        if (textToSpeech.isSpeaking()) return;
        textToSpeech.startSpeaking({
            text: msg
        });
    }
    function setLocation(lat, lon) {
        mapview.setLocation({
            latitude: lat,
            longitude: lon
        }, function(result) {
            null !== b_ls_nav && b_ls_nav.fireEvent("update_row", {
                data: lat + "," + lon
            });
            "true" == result.success && 0 === parseInt(result.marked, 10) && speak(result.message);
        });
    }
    require("alloy/controllers/base").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "old_old";
    this.args = arguments[0] || {};
    if (arguments[0]) {
        {
            __processArg(arguments[0], "__parentSymbol");
        }
        {
            __processArg(arguments[0], "$model");
        }
        {
            __processArg(arguments[0], "__itemTemplate");
        }
    }
    var $ = this;
    var exports = {};
    exports.destroy = function() {};
    _.extend($, $.__views);
    Alloy.Globals.MY_POSITION = "";
    exports.baseController = "base";
    var tiosm = require("eu.ilocate.tiosm");
    var toolkit = require("eu.ilocate.toolkit");
    var api = require("api");
    var mapview = tiosm.createView();
    var utterance = require("bencoding.utterance"), textToSpeech = utterance.createSpeech();
    var postData = {};
    postData["positionType"] = "relative";
    postData["objectId"] = Ti.Platform.macaddress;
    postData["localizationSystems"] = [];
    var temporalRouteCOntainer = [];
    var b_ls_nav = null;
    $.v_map.add(mapview);
    $.index.open();
    $.index.addEventListener("open", function() {
        getLastKnownBestLocation(function(data) {
            if (data) {
                setLocation(parseFloat(data.latitude), parseFloat(data.longitude));
                Alloy.Globals.MY_POSITION = data.latitude + "," + data.longitude;
            }
        });
    });
    $.b_search.addEventListener("gps", function(e) {
        Ti.API.info("BUTTON SEARCH EVENT ");
        Alloy.Globals.MY_POSITION.length > 0 && api.getRoutes(Alloy.Globals.MY_POSITION, e.data, e.mode, {
            success: function(data) {
                Ti.API.info(JSON.stringify(data["markers"]));
                temporalRouteCOntainer = data["markers"];
                mapview.polyline(data["legGeometry"]);
                mapview.setRoutesMarker(data["markers"]);
                $.b_step_by_step_route.backgroundImage = "/b_route_active.png";
                $.b_step_by_step_route.active = 1;
            }
        });
    });
    $.b_search.addEventListener("start", function(e) {
        temporalRouteCOntainer.length > 0 ? iterateThroughTemporalRoute(0, e.data) : alert("First assure that you have a visible route on the map, and than press start!!");
    });
    $.b_search.addEventListener("nav_list", function(e) {
        b_ls_nav = e.data;
    });
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;