function __processArg(obj, key) {
    var arg = null;
    if (obj) {
        arg = obj[key] || null;
        delete obj[key];
    }
    return arg;
}

function Controller() {
    function poiOption() {
        choose = "poi";
        emptyPoiCategory();
        var poi = Alloy.Globals.CACHED_POI["categories"];
        for (var i in poi) poiCategory.push({
            id_question: poi[i].URL,
            lbl_title: {
                text: poi[i].category
            }
        });
        labelGoBack.visible = false;
        labelSelect.visible = true;
        $.b_back.visible = false;
        $.v_option.visible = false;
        $.v_option.height = "0dp";
        $.v_search.visible = false;
        $.v_back_search.height = "80dp";
        $.b_parking.backgroundColor = "#fff";
        $.b_parking.color = "#f7c100";
        $.b_place.backgroundColor = "#eab801";
        $.b_place.color = "#fff1c0";
        fillPoiCategory();
    }
    function placeOption() {
        choose = "place";
        emptyPoiCategory();
        labelSelect.visible = false;
        $.v_option.visible = true;
        $.v_option.height = "60dp";
        $.v_back_search.height = "80dp";
        $.b_place.backgroundColor = "#fff";
        $.b_place.color = "#f7c100";
        $.b_parking.color = "#fff1c0";
        $.b_parking.backgroundColor = "#eab801";
        $.v_search.visible = true;
        $.b_back.visible = false;
    }
    function fillPoiCategory() {
        section = Ti.UI.createListSection({
            items: poiCategory
        });
        $.listView.sections = [ section ];
    }
    function emptyPoiCategory() {
        poiCategory = [];
        section = null;
        $.listView.sections = [ section ];
    }
    function setWalk() {
        $.b_walk.backgroundImage = "/b_walk_active.jpg";
        routeOption = "WALK";
        $.b_car.backgroundImage = "/b_car.jpg";
        $.b_bus.backgroundImage = "/b_bus.jpg";
    }
    function setCar() {
        $.b_car.backgroundImage = "/b_car_active.jpg";
        routeOption = "CAR";
        $.b_walk.backgroundImage = "/b_walk.jpg";
        $.b_bus.backgroundImage = "/b_bus.jpg";
    }
    function setBus() {
        $.b_bus.backgroundImage = "/b_bus_active.jpg";
        routeOption = "BUS";
        $.b_car.backgroundImage = "/b_car.jpg";
        $.b_walk.backgroundImage = "/b_walk.jpg";
    }
    function onChange(e) {
        Ti.API.info(e.value);
        if (e.value.length > 2) {
            e.value = e.value.replace(", ", ",");
            api.getGpsFromName(JSON.stringify(e.value.replace(" ", ",")), {
                onSuccess: function(data) {
                    var format_data = prepareDataForList(data);
                    section = Ti.UI.createListSection({
                        items: format_data
                    });
                    $.listView.sections = [ section ];
                },
                onError: function() {
                    alert("Server is down!");
                }
            });
        }
    }
    function prepareDataForList(data) {
        var result = [];
        for (var i in data) {
            Ti.API.info(data.geocodeAddress);
            result.push({
                id_question: data[i].latitude + "," + data[i].longitude,
                lbl_title: {
                    text: data[i].geocodeAddress
                }
            });
        }
        result.reverse();
        return result;
    }
    function onPlace(e) {
        function changeLocation() {
            Ti.App.fireEvent("updateMap", {
                what: "centerPosition",
                data: item.id_question.split(","),
                item: item,
                routeOption: routeOption
            });
        }
        var item = e.section.getItemAt(e.itemIndex);
        log("onPlace", item.lbl_title.text);
        var level = item.level;
        if (void 0 !== level && "" !== level) {
            Ti.App.SELECTED_FLOOR = parseInt(level, 10);
            Alloy.Globals.DESTINATION_LEVEL = item.level;
            console.log("Current floor is: " + Ti.App.SELECTED_FLOOR);
            Ti.App.fireEvent("setLevel", {
                level: level + ""
            });
        }
        if (void 0 !== currentLocation.lat && void 0 !== currentLocation.lon) {
            setTimeout(changeLocation, 200);
            itemSaved = item;
            Ti.App.fireEvent("showRoute", {
                what: "save",
                item: item,
                routeOption: routeOption
            });
        }
        goHome();
    }
    function onPoiSelect(e) {
        labelSelect.visible = false;
        labelGoBack.visible = true;
        var item = e.section.getItemAt(e.itemIndex);
        poiCategory = [];
        choose = "place";
        var x = Alloy.Globals.CACHED_POI[item.id_question];
        for (var i in x) poiCategory.push({
            id_question: x[i].lat + "," + x[i].lon + "," + x[i].level,
            lbl_title: {
                text: x[i].name
            },
            level: x[i].level
        });
        fillPoiCategory();
        $.b_back.visible = true;
    }
    function onItemClick(e) {
        log("onItemClick", choose);
        switch (choose) {
          case "place":
            onPlace(e);
            break;

          case "poi":
            onPoiSelect(e);
        }
    }
    require("alloy/controllers/BaseController").apply(this, Array.prototype.slice.call(arguments));
    this.__controllerPath = "search_place";
    this.args = arguments[0] || {};
    if (arguments[0]) {
        {
            __processArg(arguments[0], "__parentSymbol");
        }
        {
            __processArg(arguments[0], "$model");
        }
        {
            __processArg(arguments[0], "__itemTemplate");
        }
    }
    var $ = this;
    var exports = {};
    var __defers = {};
    $.__views.win_search_place = Ti.UI.createWindow({
        backgroundColor: "white",
        windowSoftInputMode: Ti.UI.Android.SOFT_INPUT_ADJUST_UNSPECIFIED,
        layout: "vertical",
        id: "win_search_place"
    });
    $.__views.win_search_place && $.addTopLevelView($.__views.win_search_place);
    $.__views.v_action_bar = Alloy.createController("action_bar", {
        id: "v_action_bar",
        __parentSymbol: $.__views.win_search_place
    });
    $.__views.v_action_bar.setParent($.__views.win_search_place);
    $.__views.v_category = Ti.UI.createView({
        left: 0,
        right: 0,
        height: "68dp",
        backgroundColor: "#f7c100",
        id: "v_category"
    });
    $.__views.win_search_place.add($.__views.v_category);
    $.__views.b_parking = Ti.UI.createButton({
        width: "46%",
        height: "100%",
        color: "#fff1c0",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 15,
        borderColor: "transparent",
        bottom: 0,
        left: 6,
        backgroundColor: "#eab801",
        title: "POINTS OF INTERESTS",
        zIndex: -2,
        id: "b_parking"
    });
    $.__views.v_category.add($.__views.b_parking);
    poiOption ? $.__views.b_parking.addEventListener("click", poiOption) : __defers["$.__views.b_parking!click!poiOption"] = true;
    $.__views.b_place = Ti.UI.createButton({
        width: "46%",
        height: "100%",
        color: "#f7c100",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 15,
        borderColor: "transparent",
        bottom: 0,
        right: 6,
        backgroundColor: "#fff",
        title: "SEARCH PLACE",
        zIndex: -2,
        id: "b_place"
    });
    $.__views.v_category.add($.__views.b_place);
    placeOption ? $.__views.b_place.addEventListener("click", placeOption) : __defers["$.__views.b_place!click!placeOption"] = true;
    $.__views.v_option = Ti.UI.createView({
        left: 0,
        right: 0,
        height: "60dp",
        id: "v_option"
    });
    $.__views.win_search_place.add($.__views.v_option);
    $.__views.b_walk = Ti.UI.createButton({
        width: "32%",
        height: "40dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 0,
        borderColor: "transparent",
        top: 0,
        bottom: 0,
        left: 0,
        backgroundImage: "/b_walk_active.jpg",
        id: "b_walk"
    });
    $.__views.v_option.add($.__views.b_walk);
    setWalk ? $.__views.b_walk.addEventListener("click", setWalk) : __defers["$.__views.b_walk!click!setWalk"] = true;
    $.__views.separator = Ti.UI.createLabel({
        font: {
            fontFamily: "Raleway-Medium"
        },
        color: "white",
        width: Titanium.UI.SIZE,
        top: 15,
        bottom: 15,
        backgroundColor: "#f7c100",
        visible: true,
        id: "separator"
    });
    $.__views.v_option.add($.__views.separator);
    $.__views.b_car = Ti.UI.createButton({
        width: "34%",
        height: "40dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 0,
        borderColor: "transparent",
        top: 0,
        bottom: 0,
        left: "33%",
        backgroundImage: "/b_car.jpg",
        id: "b_car"
    });
    $.__views.v_option.add($.__views.b_car);
    setCar ? $.__views.b_car.addEventListener("click", setCar) : __defers["$.__views.b_car!click!setCar"] = true;
    $.__views.separator = Ti.UI.createLabel({
        font: {
            fontFamily: "Raleway-Medium"
        },
        color: "white",
        width: Titanium.UI.SIZE,
        top: 15,
        bottom: 15,
        backgroundColor: "#f7c100",
        visible: true,
        id: "separator"
    });
    $.__views.v_option.add($.__views.separator);
    $.__views.b_bus = Ti.UI.createButton({
        width: "32%",
        height: "40dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 0,
        borderColor: "transparent",
        top: 0,
        bottom: 0,
        right: 0,
        backgroundImage: "/b_bus.jpg",
        id: "b_bus"
    });
    $.__views.v_option.add($.__views.b_bus);
    setBus ? $.__views.b_bus.addEventListener("click", setBus) : __defers["$.__views.b_bus!click!setBus"] = true;
    $.__views.v_back_search = Ti.UI.createView({
        left: 0,
        right: 0,
        height: "80dp",
        backgroundColor: "white",
        id: "v_back_search"
    });
    $.__views.win_search_place.add($.__views.v_back_search);
    $.__views.b_back = Ti.UI.createButton({
        width: "65dp",
        height: "40dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 0,
        borderColor: "transparent",
        right: 5,
        visible: false,
        backgroundImage: "/back_icon.png",
        backgroundColor: "transparent",
        id: "b_back"
    });
    $.__views.v_back_search.add($.__views.b_back);
    poiOption ? $.__views.b_back.addEventListener("click", poiOption) : __defers["$.__views.b_back!click!poiOption"] = true;
    $.__views.v_search = Ti.UI.createView({
        left: "20dp",
        right: "20dp",
        height: "40dp",
        borderRadius: "15dp",
        borderWidth: 1,
        borderColor: "gray",
        id: "v_search"
    });
    $.__views.v_back_search.add($.__views.v_search);
    $.__views.b_search = Ti.UI.createButton({
        width: "20dp",
        height: "20dp",
        color: "white",
        font: {
            fontWeight: "bold",
            fontSize: "20dp",
            fontFamily: "Raleway-Medium"
        },
        borderRadius: 0,
        borderColor: "transparent",
        backgroundImage: "/graySearch.png",
        left: "20dp",
        id: "b_search"
    });
    $.__views.v_search.add($.__views.b_search);
    $.__views.field_search = Ti.UI.createTextField({
        height: "40dp",
        autocapitalization: Ti.UI.TEXT_AUTOCAPITALIZATION_NONE,
        borderColor: "transparent",
        color: "black",
        backgroundColor: "transparent",
        font: {
            fontFamily: "Raleway-Medium",
            fontSize: "20dp"
        },
        left: "40dp",
        right: "10dp",
        id: "field_search"
    });
    $.__views.v_search.add($.__views.field_search);
    onChange ? $.__views.field_search.addEventListener("change", onChange) : __defers["$.__views.field_search!change!onChange"] = true;
    $.__views.v_divider = Ti.UI.createView({
        left: 0,
        right: 0,
        height: 1,
        backgroundColor: "black",
        top: 0,
        id: "v_divider"
    });
    $.__views.win_search_place.add($.__views.v_divider);
    var __alloyId12 = {};
    var __alloyId14 = [];
    var __alloyId15 = {
        type: "Ti.UI.View",
        childTemplates: function() {
            var __alloyId16 = [];
            var __alloyId17 = {
                type: "Ti.UI.View",
                childTemplates: function() {
                    var __alloyId18 = [];
                    var __alloyId19 = {
                        type: "Ti.UI.Label",
                        bindId: "lbl_title",
                        properties: {
                            font: {
                                fontFamily: "Raleway-Medium",
                                fontSize: "18dp"
                            },
                            color: "black",
                            left: 0,
                            text: "asd",
                            bindId: "lbl_title"
                        }
                    };
                    __alloyId18.push(__alloyId19);
                    return __alloyId18;
                }(),
                properties: {
                    left: "90dp",
                    right: "50dp",
                    top: "10dp",
                    bottom: "10dp"
                }
            };
            __alloyId16.push(__alloyId17);
            var __alloyId20 = {
                type: "Ti.UI.Button",
                properties: {
                    width: "30dp",
                    height: "30dp",
                    color: "white",
                    font: {
                        fontWeight: "bold",
                        fontSize: "20dp",
                        fontFamily: "Raleway-Medium"
                    },
                    borderRadius: 0,
                    borderColor: "transparent",
                    right: "10dp",
                    backgroundColor: "#009ab2"
                }
            };
            __alloyId16.push(__alloyId20);
            return __alloyId16;
        }(),
        properties: {
            height: "90dp",
            left: 0,
            right: 0
        }
    };
    __alloyId14.push(__alloyId15);
    var __alloyId13 = {
        properties: {
            height: "90dp",
            left: 0,
            right: 0,
            name: "template",
            bindId: "id_question"
        },
        childTemplates: __alloyId14
    };
    __alloyId12["template"] = __alloyId13;
    $.__views.listView = Ti.UI.createListView({
        templates: __alloyId12,
        id: "listView",
        defaultItemTemplate: "template",
        separatorColor: "transparent"
    });
    $.__views.win_search_place.add($.__views.listView);
    onItemClick ? $.__views.listView.addEventListener("itemclick", onItemClick) : __defers["$.__views.listView!itemclick!onItemClick"] = true;
    exports.destroy = function() {};
    _.extend($, $.__views);
    var poiCategory = [];
    var choose = "place";
    var btn_index = null;
    var api = require("api");
    var routeOption = "WALK";
    var section = null;
    var args = arguments[0] || {};
    btn_index = args["obj"];
    var currentLocation = args["currentLocation"];
    var labelSelect = Ti.UI.createLabel({
        font: {
            fontSize: 19
        },
        text: "Select a category",
        color: "#bf9b30"
    });
    var labelGoBack = Ti.UI.createLabel({
        font: {
            fontSize: 19
        },
        text: "Back to categories",
        color: "#bf9b30"
    });
    labelSelect.visible = false;
    labelGoBack.visible = false;
    $.v_back_search.add(labelSelect);
    $.v_back_search.add(labelGoBack);
    $.v_action_bar.getView("action_bar").addEventListener("onButtonClick", function(e) {
        "close" == e.action ? close($.win_search_place) : openWindow(Alloy.createController("settings").getView());
    });
    $.win_search_place.addEventListener("close", function() {
        $.v_action_bar.getView("action_bar").removeEventListener("onButtonClick", function() {});
        $.destroy();
    });
    __defers["$.__views.b_parking!click!poiOption"] && $.__views.b_parking.addEventListener("click", poiOption);
    __defers["$.__views.b_place!click!placeOption"] && $.__views.b_place.addEventListener("click", placeOption);
    __defers["$.__views.b_walk!click!setWalk"] && $.__views.b_walk.addEventListener("click", setWalk);
    __defers["$.__views.b_car!click!setCar"] && $.__views.b_car.addEventListener("click", setCar);
    __defers["$.__views.b_bus!click!setBus"] && $.__views.b_bus.addEventListener("click", setBus);
    __defers["$.__views.b_back!click!poiOption"] && $.__views.b_back.addEventListener("click", poiOption);
    __defers["$.__views.field_search!change!onChange"] && $.__views.field_search.addEventListener("change", onChange);
    __defers["$.__views.listView!itemclick!onItemClick"] && $.__views.listView.addEventListener("itemclick", onItemClick);
    _.extend($, exports);
}

var Alloy = require("alloy"), Backbone = Alloy.Backbone, _ = Alloy._;

module.exports = Controller;